# Niobium

This README would normally document whatever steps are necessary to get your application up and running.

## What is this?

* Quick summary
* Version
* [Learn Markdown](https://bitbucket.org/tutorials/markdowndemo)

## Downloading
```
#!bash
git clone https://crimoniv@bitbucket.org/crimoniv/niobium.git
cd niobium
git clone https://crimoniv@bitbucket.org/crimoniv/niobium.git/wiki

```

## Documentation ##

### Installation ###
```
#!bash
git clone https://crimoniv@bitbucket.org/crimoniv/niobium.git
cd niobium
# To install Sails locally
npm install # Will install all other dependencies
node app.js
# To install globally
sudo npm install sails@beta -g
npm install
sails lift
```

### New Controller Steps ###

```
sails generate model Role
sails generate controller Role
```

>./api/controllers/RoleController.js:  
>Create: new, show, edit, create, update, index, destroy

>./api/models/Role.js:  
>Create: formFields, listFields

>./config/niobium.js:  
>Configure: breadcrumb: { role: ... }, navbar: { role: ... }

>./config/policies.js:  
>Configure: { role: ... }

>./assets/js/form_validators/roleModelFormValidation.js:  
>Configure: $('#nbm-model-form-role').bootstrapValidator();

## Licensing
Please see the file called LICENSE.

## Others

### Known Issues ###

> All queries inside of Waterline are case insensitive. This allows for easier querying but makes indexing strings tough. This is something to be aware of if you are indexing and searching on string fields.

* Issue: Multiple users with similar `name` can coexist (e.g., `user1` and `uSer1`), but only first can create a new session.
* Workaround: Always transform `name` to lower case.
* Info: https://github.com/balderdashy/waterline-docs/blob/master/query-language.md#query-language

> Waterline does not support recursive population

* Issue: The `Role.permissions` attribute must be accesible through `User.roles.permissions`.
* Workaround: See `skrichten ` answer.
* Info: https://github.com/balderdashy/waterline/issues/256

> Waterline is unable to set a collection as empty through `Model.update()`.

* Issue: `Users` must have, at least, one `Role` assigned.
* Workaround: Create `none` role with no permissions.

> The required permissions to edit/set Model attributes must be checked on `Model.beforeValidation()`.

* Issue: `config/bootstrap.js` creates some records at boot time that require special permissions.
* Workaround: ???

> Does not exist any callback on find (beforeFind/afterFind).

* Issue: Cannot get `BinaryImage.url` as a computed field, the function must be called manually.
* Workaround: BinaryImage.url must be declared as function and overwrited with `img.url = img.url()` instead of computed after every find.

> Cascading deletes does not exist currently.

* Issue: Build logs are not deleted when deleting a BinaryImage record.
* Workaround: Can be implemented using `beforeDestroy`/`afterDestroy`, but thi feature will come in the future: https://github.com/balderdashy/waterline/issues/251

### How do I get set up? ###

* Summary of set up
* Configuration
* Dependencies
* Database configuration
* How to run tests
* Deployment instructions

### Contribution guidelines ###

* Writing tests
* Code review
* Other guidelines

### Who do I talk to? ###

* Repo owner or admin
* Other community or team contact