#!/bin/bash

# Start execution in background with sudo
/usr/bin/sudo /usr/bin/bash - <&0 &

# Get sudo PID
SUDO_PID=$!

# Send kill to sudo PGID (with the process previously detached from node.js)
# when trap catches a signal
sigterm_sudo ()
{
    # Clear trap to avoid loop
    trap - 1 2 3 15
    
    # Get PGID and kill group
    SUDO_PGID=$(ps -p ${SUDO_PID} -o pgid= | sed -e 's/^[ \t]*//')
    if [ ! -z "${SUDO_PGID}" ]; then
        echo "Killing w/ 'kill -TERM -${SUDO_PGID}'..."
        echo "kill -TERM -${SUDO_PGID}" | /usr/bin/sudo /usr/bin/bash -
    fi
    # BASH_PID=$(ps --ppid ${SUDO_PID} -o pid=)
    # echo "kill -SIGTERM -${BASH_PID}" | /usr/bin/sudo /usr/bin/bash -
}

trap sigterm_sudo 1 2 3 15

# Wait to sudo before exiting. Return exit code
wait ${SUDO_PID}
