/**
 * DashboardController
 *
 * @description :: Server-side logic for managing dashboards
 * @help        :: See http://links.sailsjs.org/docs/controllers
 */

module.exports = {
    
    /** 
     * Default view for authenticated users
     */
    index: function (req, res, next) {
        Config.getServerStatus(function (err, status) {
            if ( err ) {
                return next(err);
            }
            
            return res.view({
                servers: status
            });
        });
        
    },
    
    subscribe: function (req, res, next) {
        // Subscribe user to `dashboard` room
        if ( req.isSocket ) {
            sails.sockets.join(req.socket, 'dashboard');
            return res.ok();
        }
        return res.badRequest();
    }
    
};
