/**
* Permission.js
*
* @description :: TODO: You might write a short summary of how this model works and what it represents here.
* @docs        :: http://sailsjs.org/#!documentation/models
*/

module.exports = {
    
    attributes: {
        
        /**
         * Nombre el permiso.
         */
        name: {
            type: 'string',
            unique: true,
            required: true,
            notNull: true
        },
        
        /**
         * Roles a los que se les asigna.
         */
        roles: {
            collection: 'role',
            via: 'permissions'
        },
        
        /**
         * Sobreescribimos la función toJSON.
         */
        toJSON: function () {
            var obj = this.toObject();
            return obj;
        }
        
    },
    
    /**
     * Form builder
     */
    formFields: [{
        name: 'id',
        label: 'Id',
        type: 'text',
    }, {
        name: 'name',
        label: 'Name*',
        type: 'text',
        attrs: {
            'data-writable': true,
            'data-bv-stringlength': 'true',
            'data-bv-stringlength-min': 3,
            'data-bv-notempty': 'true',
        }
    }, {
        name: 'roles',
        label: 'Roles',
        relation: 'role',
        type: 'select',
        multiple: true,
        attrs: {
            'data-editable': true,
            'title': 'No roles assigned',
        },
        perms: 'manageRoles',
        // Must be injected: { id: '...', name: '...' }
        values: []
    }],
    
    /**
     * List Builder. Max col-md-10
     */
    listFields: [{
        name: 'id',
        label: '#',
        'class': 'col-md-1'
    }, {
        name: 'name',
        label: 'Name',
        'class': 'col-md-9'
    }]
};

