module.exports = function (req, res, next) {
    sails.log.debug('Policy: hasBreadcrumb');
    var path = req.route.path;
    var breadcrumb = _.cloneDeep(sails.config.niobium.schema);
    
    /**
     * Recursive search on the breadcrumb variable. Returns
     * current path.
     */
    var bc = [];
    var buildBreadcrumb = function (needle, obj) {
        return ! _.every(obj, function (o) {
            var found = ( o.route === needle || o.href === needle );
            if ( found ) {
                o.href = req.originalUrl;
                bc.unshift(o);
                return false;
            } else if ( o.sub ) {
                if ( buildBreadcrumb(needle, o.sub) ) {
                    bc.unshift(o);
                    return false;
                } else {
                    return true;
                }
            } else {
                return true;
            }
        });
    };
    buildBreadcrumb(path, breadcrumb);
    
    // sails.log.debug('path', path);
    // sails.log.debug('bc', bc);
    res.locals._bc_paths = bc;
    return next();
};