/**
 * Debootstrap NFS connector
 */
module.exports = {
    path: '/srv/nbm/builds/deb',
    ipxe: [
        //'kernel %(url)s/%(kernel)s boot=live config quiet splash netboot=nfs ro root=/dev/nfs ip=dhcp nfsroot=%(server)s:%(nfsroot)s',
        'kernel %(url)s/%(kernel)s ro root=/dev/nfs ip=dhcp nfsroot=%(server)s:%(nfsroot)s vga=0x316',
        'initrd %(url)s/%(initrd)s'
    ],
    
    kernel: 'vmlinuz',
    initrd: 'initrd.img',
    nfsroot: 'root',
    nfsopts: 'ro,no_root_squash,async,no_subtree_check',
    
    env: _.merge({}, require('./defaults/debootstrap_1.0.60.js'), {
        // _deb_packages: 'xfce4,alsa-base,thunar-volman,tumbler,xorg,' +
        //                'tango-icon-theme,xfce4-terminal,xfce4-notifyd,xscreensaver,' +
        //                'xfce4-volumed,thunar-archive-plugin,file-roller,gvfs,' +
        //                'chromium,chromium-inspector,chromium-l10n',
        deb_rootfs: 'nfs'
    })
};