/**
 * Live-build NFS connector
 */
module.exports = {
    path: '/srv/nbm/builds/lb',
    ipxe: [
        'kernel %(url)s/%(kernel)s boot=live config quiet splash netboot=nfs ro root=/dev/nfs ip=dhcp nfsroot=%(server)s:%(nfsroot)s',
        'initrd %(url)s/%(initrd)s'
    ],
    
    kernel: 'vmlinuz',
    initrd: 'initrd.img',
    nfsroot: '',
    nfsopts: 'ro,no_root_squash,async,no_subtree_check',
    
    env: _.merge({}, require('./defaults/lb_3.0.5-1.js'), {
        _lb_packages: 'vim lynx user-setup sudo',
        lb_chroot_filesystem: 'plain',
        lb_apt_indices: 'false',
        lb_apt_recommends: 'false',
        lb_debootstrap_options: '--variant=minbase', // requires: user-setup sudo
        lb_net_root_filesystem: 'nfs',
    })
};