(function($) {
    $.fn.bootstrapValidator.validators.rfc1035 = {
        validate: function(validator, $field, options) {
            var value = $field.val();
            
            if ( ! value.length ) {
                return {
                    valid: false,
                    message: 'The value cannot be empty'
                };
            }
            // Check the value strength
            if (value.length > 253) {
                return {
                    valid: false,
                    message: 'The value cannot exceed 253 characters'
                };
            }
            
            // Test for forbidden characters
            if ( ! /^[a-z0-9-]{1,253}$/.test(value) ) {
                return {
                    valid: false,
                    message: 'The allowed character set is [a-z], [0-9] and -'
                };
            }
            
            return true;
        }
    };
}(window.jQuery));
