/**
 * Policy Mappings
 * (sails.config.policies)
 *
 * Policies are simple functions which run **before** your controllers.
 * You can apply one or more policies to a given controller, or protect
 * its actions individually.
 *
 * Any policy file (e.g. `api/policies/authenticated.js`) can be accessed
 * below by its filename, minus the extension, (e.g. "authenticated")
 *
 * For more information on configuring policies, check out:
 * http://sailsjs.org/#!documentation/
 */


module.exports.policies = {

    // Default policy for all controllers and actions
    // (`true` allows public access)
    '*': [],
    
    index: {
        '*': ['flash']
    },
    
    dashboard: {
        // '*': ['sessionAuth'],
        '*': ['sessionAuth', 'flash', 'hasNavbar', 'hasBreadcrumb']
        // 'index': ['sessionAuth', 'flash', 'hasNavbar', 'hasBreadcrumb']
    },
    
    config: {
        // '*': ['sessionAuth'],
        '*': ['sessionAuth', 'flash', 'hasNavbar', 'hasBreadcrumb']
        // 'index': ['sessionAuth', 'flash', 'hasNavbar', 'hasBreadcrumb']
    },
    
    // hasNavbar & hasBreadcrumb will be removed (after AJAX)
    // idRequired must disappear after inheritance is implemented
    user: {
        // '*': ['sessionAuth'],
        '*': ['sessionAuth', 'hasNavbar', 'permManageUsers', 'idRequired', 'flash', 'hasBreadcrumb'],
        'index': ['sessionAuth', 'hasNavbar', 'permManageUsers', 'flash', 'hasBreadcrumb'],
        'new': ['sessionAuth', 'hasNavbar', 'permManageUsers', 'flash', 'hasBreadcrumb'],
        // 'show': ['sessionAuth', 'hasNavbar', 'permManageUsers', 'idRequired', 'flash', 'hasBreadcrumb'],
        // 'edit': ['sessionAuth', 'hasNavbar', 'permManageUsers', 'idRequired', 'flash', 'hasBreadcrumb'],
        'create': ['sessionAuth', 'hasNavbar', 'permManageUsers', 'flash', 'hasBreadcrumb'],
        // 'update': ['sessionAuth', 'hasNavbar', 'permManageUsers', 'idRequired', 'flash'],
        // 'destroy':  ['sessionAuth', 'hasNavbar', 'permManageUsers', 'idRequired', 'flash'],
        'destroyMultiple': ['sessionAuth', 'hasNavbar', 'permManageUsers', 'flash', 'hasBreadcrumb'],
    },

    role: {
        // '*': ['sessionAuth'],
        '*': ['sessionAuth', 'hasNavbar', 'permManageRoles', 'idRequired', 'flash', 'hasBreadcrumb'],
        'index': ['sessionAuth', 'hasNavbar', 'permManageRoles', 'flash', 'hasBreadcrumb'],
        'new': ['sessionAuth', 'hasNavbar', 'permManageRoles', 'flash', 'hasBreadcrumb'],
        // 'show': ['sessionAuth', 'hasNavbar', 'permManageRoles', 'idRequired', 'flash', 'hasBreadcrumb'],
        // 'edit': ['sessionAuth', 'hasNavbar', 'permManageRoles', 'idRequired', 'flash', 'hasBreadcrumb'],
        'create': ['sessionAuth', 'hasNavbar', 'permManageRoles', 'flash', 'hasBreadcrumb'],
        // 'update': ['sessionAuth', 'hasNavbar', 'permManageRoles', 'idRequired', 'flash'],
        // 'destroy':  ['sessionAuth', 'hasNavbar', 'permManageRoles', 'idRequired', 'flash'],
        'destroyMultiple': ['sessionAuth', 'hasNavbar', 'permManageRoles', 'flash', 'hasBreadcrumb'],
    },
    
    permission: {
        // '*': ['sessionAuth'],
        '*': ['sessionAuth', 'hasNavbar', 'permManagePermissions', 'idRequired', 'flash', 'hasBreadcrumb'],
        'index': ['sessionAuth', 'hasNavbar', 'permManagePermissions', 'flash', 'hasBreadcrumb'],
        'new': ['sessionAuth', 'hasNavbar', 'permManagePermissions', 'flash', 'hasBreadcrumb'],
        // 'show': ['sessionAuth', 'hasNavbar', 'permManagePermissions', 'idRequired', 'flash', 'hasBreadcrumb'],
        // 'edit': ['sessionAuth', 'hasNavbar', 'permManagePermissions', 'idRequired', 'flash', 'hasBreadcrumb'],
        'create': ['sessionAuth', 'hasNavbar', 'permManagePermissions', 'flash', 'hasBreadcrumb'],
        // 'update': ['sessionAuth', 'hasNavbar', 'permManagePermissions', 'idRequired', 'flash'],
        // 'destroy':  ['sessionAuth', 'hasNavbar', 'permManagePermissions', 'idRequired', 'flash'],
        'destroyMultiple': ['sessionAuth', 'hasNavbar', 'permManagePermissions', 'flash', 'hasBreadcrumb'],
    },
    
    client: {
        // '*': ['sessionAuth'],
        '*': ['sessionAuth', 'hasNavbar', 'permManageClients', 'idRequired', 'flash', 'hasBreadcrumb'],
        'index': ['sessionAuth', 'hasNavbar', 'permManageClients', 'flash', 'hasBreadcrumb'],
        'new': ['sessionAuth', 'hasNavbar', 'permManageClients', 'flash', 'hasBreadcrumb'],
        // 'show': ['sessionAuth', 'hasNavbar', 'permManageClients', 'idRequired', 'flash', 'hasBreadcrumb'],
        // 'edit': ['sessionAuth', 'hasNavbar', 'permManageClients', 'idRequired', 'flash', 'hasBreadcrumb'],
        'create': ['sessionAuth', 'hasNavbar', 'permManageClients', 'flash', 'hasBreadcrumb'],
        // 'update': ['sessionAuth', 'hasNavbar', 'permManageClients', 'idRequired', 'flash'],
        // 'destroy':  ['sessionAuth', 'hasNavbar', 'permManageClients', 'idRequired', 'flash'],
        'destroyMultiple': ['sessionAuth', 'hasNavbar', 'permManageClients', 'flash', 'hasBreadcrumb'],
    },
    
    binaryImage: {
        // '*': ['sessionAuth'],
        '*': ['sessionAuth', 'hasNavbar', 'permManageImages', 'idRequired', 'flash', 'hasBreadcrumb'],
        'index': ['sessionAuth', 'hasNavbar', 'permManageImages', 'flash', 'hasBreadcrumb'],
        'new': ['sessionAuth', 'hasNavbar', 'permManageImages', 'flash', 'hasBreadcrumb'],
        // 'show': ['sessionAuth', 'hasNavbar', 'permManageImages', 'idRequired', 'flash', 'hasBreadcrumb'],
        // 'edit': ['sessionAuth', 'hasNavbar', 'permManageImages', 'idRequired', 'flash', 'hasBreadcrumb'],
        'create': ['sessionAuth', 'hasNavbar', 'permManageImages', 'flash', 'hasBreadcrumb'],
        // 'update': ['sessionAuth', 'hasNavbar', 'permManageImages', 'idRequired', 'flash'],
        // 'destroy':  ['sessionAuth', 'hasNavbar', 'permManageImages', 'idRequired', 'flash'],
        'destroyMultiple': ['sessionAuth', 'hasNavbar', 'permManageImages', 'flash', 'hasBreadcrumb'],
    },
    
    clientGroup: {
        // '*': ['sessionAuth'],
        '*': ['sessionAuth', 'hasNavbar', 'permManageGroups', 'idRequired', 'flash', 'hasBreadcrumb'],
        'index': ['sessionAuth', 'hasNavbar', 'permManageGroups', 'flash', 'hasBreadcrumb'],
        'new': ['sessionAuth', 'hasNavbar', 'permManageGroups', 'flash', 'hasBreadcrumb'],
        // 'show': ['sessionAuth', 'hasNavbar', 'permManageGroups', 'idRequired', 'flash', 'hasBreadcrumb'],
        // 'edit': ['sessionAuth', 'hasNavbar', 'permManageGroups', 'idRequired', 'flash', 'hasBreadcrumb'],
        'create': ['sessionAuth', 'hasNavbar', 'permManageGroups', 'flash', 'hasBreadcrumb'],
        // 'update': ['sessionAuth', 'hasNavbar', 'permManageGroups', 'idRequired', 'flash'],
        // 'destroy':  ['sessionAuth', 'hasNavbar', 'permManageGroups', 'idRequired', 'flash'],
        'destroyMultiple': ['sessionAuth', 'hasNavbar', 'permManageGroups', 'flash', 'hasBreadcrumb'],
    },
    
    build: {
        '*': ['sessionAuth', 'hasNavbar', 'permManageImages', 'flash', 'hasBreadcrumb'],
    }
    
	// Here's an example of mapping some policies to run before
    // a controller and its actions
	// RabbitController: {

		// Apply the `false` policy as the default for all of RabbitController's actions
		// (`false` prevents all access, which ensures that nothing bad happens to our rabbits)
		// '*': false,

		// For the action `nurture`, apply the 'isRabbitMother' policy
		// (this overrides `false` above)
		// nurture	: 'isRabbitMother',

		// Apply the `isNiceToAnimals` AND `hasRabbitFood` policies
		// before letting any users feed our rabbits
		// feed : ['isNiceToAnimals', 'hasRabbitFood']
	// }
};
